<template>
    <span class="bubble">
        {{ item.price }}
        <span :class="['stats-arr', `stats-arr-${flag}`]"></span>
        <match-table-row-history
            v-if="showBets"
            :bets="Object.values(bets)"
            :current="current"
            :opening="opening"
            :info="info"
            :bets-loaded="betsLoaded"
        />
    </span>
</template>

<script>
    import MatchTableRowHistory from './MatchTableRowHistory'
    import Api from '../../../JokerApi'

    export default {
        name: 'MatchTableRowBubble',
        props: {
            item: Object,
            betHistory: Object
        },
        data() {
            return {
                showBets: false,
                betsLoaded: false,
                bets: [],
                current: {},
                opening: {},
                info: {},
                flag: 'up'
            }
        },
        methods: {
            getHistory(item) {
                if (this.betsLoaded) {
                    this.$log.debug('this.betsHistory.loaded === true')
                    this.showBetsHistory()
                } else {
                    this.$log.debug('this.betsHistory.loaded === false')
                    this.showBetsHistory()
                    const api = new Api
                    let market = item.market_id
                    let bookmaker = item.bookmaker_id
                    let event = this.$route.params.id

                    api.getBetHistory(
                        item.name, event, bookmaker, market,item.base_line
                    ).then((response) => {
                        this.bets = response[0].bets
                        this.current = response[0].current
                        this.opening = response[0].opening
                        this.info = response[0].info
                        this.betsLoaded = true
                        this.$forceUpdate()
                        this.$log.debug('response', response, this.betsHistory)
                    }).catch(err => console.error(err))
                    this.$forceUpdate()
                }
            },

            itemValuesDifferent(item) {
                return item.price !== item.start_price
            },
            itemValuesArr(item) {
                let length = this.bets.length;
                if(!length){
                    return item.price > item.start_price ? 'up' : 'down'
                } else if(length===1){
                    return this.bets[0]['price'] > item.start_price ? 'up' : 'down'
                }
                return this.bets[length - 1]['price'] >  item.start_price ? 'up' : 'down'

            },
            ifSet(value) {
                if (value !== undefined && value !== false && value !== null) {
                    return value
                } else {
                    return false
                }
            },
            showBetsHistory() {
                this.showBets = true
            },
            hideBetsHistory() {
                this.showBets = false
            }
        },

        mounted() {
            let length = this.bets.length;
            if(!length){
                this.flag =  this.item.price > this.item.start_price ? 'up' : 'down';
            } else if(length===1){
                this.flag = this.bets[0]['price'] > this.item.start_price ? 'up' : 'down';
            } else{
                this.flag =  this.bets[length-1]['price'] >  this.bets[length-2]['price'] ? 'up' : 'down';
            }
        },
        watch:{
          bets(val){
              let length = this.bets.length;
              if(!length){
                  this.flag =  this.item.price > this.item.start_price ? 'up' : 'down';
              } else if(length===1){
                  this.flag = this.bets[0]['price'] > this.item.start_price ? 'up' : 'down';
              } else{
                  this.flag =  this.bets[0]['price'] >  this.bets[1]['price'] ? 'up' : 'down';
              }
            }
        },
        components: {MatchTableRowHistory},
    }
</script>

<style scoped>

</style>
